/*****************************************************************************
 * portcls.h - WDM Streaming port class driver
 *****************************************************************************
 * Copyright (c) Microsoft Corporation 1996
 */

#ifndef _PORTCLS_H_
#define _PORTCLS_H_

#ifdef __cplusplus
// WDM.H does not play well with C++.
extern "C"
{
#include <wdm.h>
}
#else
#include <wdm.h>
#endif

#include <windef.h>
#define NOBITMAP
#include <mmreg.h>
#undef NOBITMAP
#include "ks.h"
#include "ksmedia.h"
#include "unknown.h"

#ifdef __cplusplus
#define PORTCLASSAPI extern "C"
#else
#define PORTCLASSAPI
#endif




/*****************************************************************************
 * Interface identifiers.
 */

DEFINE_GUID(IID_IMiniport,
0xb4c90a24, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPort,
0xb4c90a25, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IResourceList,
0x22C6AC60L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IDmaChannel,
0x22C6AC61L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IAccessSync,
0x22C6AC62L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IInterruptSync,
0x22C6AC63L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IServiceGroupSink,
0x22C6AC64L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IServiceGroup,
0x22C6AC65L, 0x851B, 0x11D0, 0x9A, 0x7F, 0x00, 0xAA, 0x00, 0x38, 0xAC, 0xFE);
DEFINE_GUID(IID_IRegistryKey,
0xE8DA4302, 0xF304, 0x11D0, 0x95, 0x8B, 0x00, 0xC0, 0x4F, 0xB9, 0x25, 0xD3);
DEFINE_GUID(IID_IPortMidi,
0xb4c90a40, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportMidi,
0xb4c90a41, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportMidiStream,
0xb4c90a42, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortTopology,
0xb4c90a30, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportTopology,
0xb4c90a31, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortWaveCyclic,
0xb4c90a26, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWaveCyclic,
0xb4c90a27, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWaveCyclicStream,
0xb4c90a28, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortWavePci,
0xb4c90a50, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortWavePciStream,
0xb4c90a51, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWavePci,
0xb4c90a52, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWavePciStream,
0xb4c90a53, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortWavetable,
0xb4c90af0, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IPortWavetableVoice,
0xb4c90af2, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWavetable,
0xb4c90af1, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(IID_IMiniportWavetableVoice,
0xb4c90af3, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);





/*****************************************************************************
 * Class identifiers.
 */

DEFINE_GUID(CLSID_PortMidi,
0xb4c90a43, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_PortTopology,
0xb4c90a32, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_PortWaveCyclic,
0xb4c90a2a, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_PortWavePci,
0xb4c90a54, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_PortWavetable,
0xb4c90af2, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_MiniportDriverFmSynth,
0xb4c90ae0, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);
DEFINE_GUID(CLSID_MiniportDriverUart,
0xb4c90ae1, 0x5791, 0x11d0, 0x86, 0xf9, 0x0, 0xa0, 0xc9, 0x11, 0xb5, 0x44);





/*****************************************************************************
 * Interfaces
 */

/*****************************************************************************
 * IResourceList
 *****************************************************************************
 * List of resources.
 */
DECLARE_INTERFACE_(IResourceList,IUnknown)
{
    STDMETHOD_(ULONG,NumberOfEntries)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,NumberOfEntriesOfType)
    (   THIS_
        IN      CM_RESOURCE_TYPE    Type
    )   PURE;

    STDMETHOD_(PCM_PARTIAL_RESOURCE_DESCRIPTOR,FindTranslatedEntry)
    (   THIS_
        IN      CM_RESOURCE_TYPE    Type,
        IN      ULONG               Index
    )   PURE;

    STDMETHOD_(PCM_PARTIAL_RESOURCE_DESCRIPTOR,FindUntranslatedEntry)
    (   THIS_
        IN      CM_RESOURCE_TYPE    Type,
        IN      ULONG               Index
    )   PURE;

    STDMETHOD(AddEntry)
    (   THIS_
        IN      PCM_PARTIAL_RESOURCE_DESCRIPTOR Translated,
        IN      PCM_PARTIAL_RESOURCE_DESCRIPTOR Untranslated
    )   PURE;

    STDMETHOD(AddEntryFromParent)
    (   THIS_
        IN      struct IResourceList *  Parent,
        IN      CM_RESOURCE_TYPE        Type,
        IN      ULONG                   Index
    )   PURE;

    STDMETHOD_(PCM_RESOURCE_LIST,TranslatedList)
    (   THIS
    )   PURE;

    STDMETHOD_(PCM_RESOURCE_LIST,UntranslatedList)
    (   THIS
    )   PURE;
};

typedef IResourceList *PRESOURCELIST;


#define NumberOfPorts()         NumberOfEntriesOfType(CmResourceTypePort)
#define FindTranslatedPort(n)   FindTranslatedEntry(CmResourceTypePort,(n))
#define FindUntranslatedPort(n) FindUntranslatedEntry(CmResourceTypePort,(n))
#define AddPortFromParent(p,n)  AddEntryFromParent((p),CmResourceTypePort,(n))

#define NumberOfInterrupts()         NumberOfEntriesOfType(CmResourceTypeInterrupt)
#define FindTranslatedInterrupt(n)   FindTranslatedEntry(CmResourceTypeInterrupt,(n))
#define FindUntranslatedInterrupt(n) FindUntranslatedEntry(CmResourceTypeInterrupt,(n))
#define AddInterruptFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeInterrupt,(n))

#define NumberOfMemories()        NumberOfEntriesOfType(CmResourceTypeMemory)
#define FindTranslatedMemory(n)   FindTranslatedEntry(CmResourceTypeMemory,(n))
#define FindUntranslatedMemory(n) FindUntranslatedEntry(CmResourceTypeMemory,(n))
#define AddMemoryFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeMemory,(n))

#define NumberOfDmas()         NumberOfEntriesOfType(CmResourceTypeDma)
#define FindTranslatedDma(n)   FindTranslatedEntry(CmResourceTypeDma,(n))
#define FindUntranslatedDma(n) FindUntranslatedEntry(CmResourceTypeDma,(n))
#define AddDmaFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeDma,(n))

#define NumberOfDeviceSpecifics()         NumberOfEntriesOfType(CmResourceTypeDeviceSpecific)
#define FindTranslatedDeviceSpecific(n)   FindTranslatedEntry(CmResourceTypeDeviceSpecific,(n))
#define FindUntranslatedDeviceSpecific(n) FindUntranslatedEntry(CmResourceTypeDeviceSpecific,(n))
#define AddDeviceSpecificFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeDeviceSpecific,(n))

#define NumberOfBusNumbers()         NumberOfEntriesOfType(CmResourceTypeBusNumber)
#define FindTranslatedBusNumber(n)   FindTranslatedEntry(CmResourceTypeBusNumber,(n))
#define FindUntranslatedBusNumber(n) FindUntranslatedEntry(CmResourceTypeBusNumber,(n))
#define AddBusNumberFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeBusNumber,(n))

#define NumberOfDevicePrivates()         NumberOfEntriesOfType(CmResourceTypeDevicePrivate)
#define FindTranslatedDevicePrivate(n)   FindTranslatedEntry(CmResourceTypeDevicePrivate,(n))
#define FindUntranslatedDevicePrivate(n) FindUntranslatedEntry(CmResourceTypeDevicePrivate,(n))
#define AddDevicePrivateFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeDevicePrivate,(n))

#define NumberOfAssignedResources()         NumberOfEntriesOfType(CmResourceTypeAssignedResource)
#define FindTranslatedAssignedResource(n)   FindTranslatedEntry(CmResourceTypeAssignedResource,(n))
#define FindUntranslatedAssignedResource(n) FindUntranslatedEntry(CmResourceTypeAssignedResource,(n))
#define AddAssignedResourceFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeAssignedResource,(n))

#define NumberOfSubAllocateFroms()         NumberOfEntriesOfType(CmResourceTypeSubAllocateFrom)
#define FindTranslatedSubAllocateFrom(n)   FindTranslatedEntry(CmResourceTypeSubAllocateFrom,(n))
#define FindUntranslatedSubAllocateFrom(n) FindUntranslatedEntry(CmResourceTypeSubAllocateFrom,(n))
#define AddSubAllocateFromFromParent(p,n)  AddEntryFromParent((p),CmResourceTypeSubAllocateFrom,(n))

/*****************************************************************************
 * IDmaChannel
 *****************************************************************************
 * Interface for DMA channel.
 */
DECLARE_INTERFACE_(IDmaChannel,IUnknown)
{
    STDMETHOD(AllocateBuffer)
    (   THIS_
        IN      ULONG               BufferSize,
        IN      PPHYSICAL_ADDRESS   PhysicalAddressConstraint   OPTIONAL
    )   PURE;

    STDMETHOD_(void,FreeBuffer)
    (   THIS
    )   PURE;

    STDMETHOD(Start)
    (   THIS_
        IN      ULONG               MapSize,
        IN      BOOLEAN             WriteToDevice
    )   PURE;

    STDMETHOD(Stop)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,ReadCounter)
    (   THIS
    )   PURE;

    STDMETHOD(MapPhysicalToUserSpace)
    (   THIS
    )   PURE;

    STDMETHOD_(void,UnmapUserSpace)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,TransferCount)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,MaximumBufferSize)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,AllocatedBufferSize)
    (   THIS
    )   PURE;

    STDMETHOD_(ULONG,BufferSize)
    (   THIS
    )   PURE;

    STDMETHOD_(void,SetBufferSize)
    (   THIS_
        IN      ULONG   BufferSize
    )   PURE;

    STDMETHOD_(PVOID,SystemAddress)
    (   THIS
    )   PURE;

    STDMETHOD_(PHYSICAL_ADDRESS,PhysicalAddress)
    (   THIS
    )   PURE;

    STDMETHOD_(PVOID,UserAddress)
    (   THIS
    )   PURE;

    STDMETHOD_(PADAPTER_OBJECT,GetAdapterObject)
    (   THIS
    )   PURE;
};

typedef IDmaChannel *PDMACHANNEL;

/*****************************************************************************
 * PINTERRUPTSYNCROUTINE
 *****************************************************************************
 * Pointer to an interrupt synchronization routine.  Both interrupt service
 * routines and routines that are synchronized with ISRs use this type.
 */
typedef NTSTATUS
(*PINTERRUPTSYNCROUTINE)
(
    IN      struct IInterruptSync * InterruptSync,
    IN      PVOID                   StaticContext   OPTIONAL,
    IN      PVOID                   DynamicContext  OPTIONAL
);

/*****************************************************************************
 * IInterruptSync
 *****************************************************************************
 * Interface for objects providing access synchronization with interrupts.
 */
DECLARE_INTERFACE_(IInterruptSync,IUnknown)
{
    STDMETHOD(CallSynchronizedRoutine)
    (   THIS_
        IN      PINTERRUPTSYNCROUTINE   Routine,
        IN      PVOID                   DynamicContext
    )   PURE;
};

typedef IInterruptSync *PINTERRUPTSYNC;

/*****************************************************************************
 * IAccessSync
 *****************************************************************************
 * Interface for objects providing access synchronization at passive and
 * dispatch level.
 */
DECLARE_INTERFACE_(IAccessSync,IUnknown)
{
    STDMETHOD(Begin)
    (   THIS
    )   PURE;

    STDMETHOD_(void,End)
    (   THIS
    )   PURE;
};

typedef IAccessSync *PACCESSSYNC;

/*****************************************************************************
 * IServiceGroupSink
 *****************************************************************************
 * Interface for notification sinks for service groups.
 */
DECLARE_INTERFACE_(IServiceGroupSink,IUnknown)
{
    STDMETHOD_(void,RequestService)
    (   THIS
    )   PURE;
};

typedef IServiceGroupSink *PSERVICEGROUPSINK;

/*****************************************************************************
 * IServiceGroup
 *****************************************************************************
 * Interface for objects representing a group that is serviced collectively.
 */
DECLARE_INTERFACE_(IServiceGroup,IServiceGroupSink)
{
    STDMETHOD_(BOOLEAN,QueryService)
    (   THIS_
        IN OUT  PULONG  Counter
    )   PURE;

    STDMETHOD_(void,AddMember)
    (   THIS
    )   PURE;

    STDMETHOD_(void,RemoveMember)
    (   THIS
    )   PURE;

    STDMETHOD_(void,SetSink)
    (   THIS_
        IN      PSERVICEGROUPSINK   Sink    OPTIONAL
    )   PURE;
};

typedef IServiceGroup *PSERVICEGROUP;

/*****************************************************************************
 * IRegistryKey
 *****************************************************************************
 * Interface for objects providing access to a registry key.
 */
DECLARE_INTERFACE_(IRegistryKey,IUnknown)
{
    STDMETHOD(QueryKey)
    (   THIS_
        IN      KEY_INFORMATION_CLASS   KeyInformationClass,
        OUT     PVOID                   KeyInformation,
        IN      ULONG                   Length,
        OUT     PULONG                  ResultLength
    )   PURE;

    STDMETHOD(EnumerateKey)
    (   THIS_
        IN      ULONG                   Index,
        IN      KEY_INFORMATION_CLASS   KeyInformationClass,
        OUT     PVOID                   KeyInformation,
        IN      ULONG                   Length,
        OUT     PULONG                  ResultLength
    )   PURE;

    STDMETHOD(QueryValueKey)
    (   THIS_
        IN      PUNICODE_STRING             ValueName,
        IN      KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass,
        OUT     PVOID                       KeyValueInformation,
        IN      ULONG                       Length,
        OUT     PULONG                      ResultLength
    )   PURE;

    STDMETHOD(EnumerateValueKey)
    (   THIS_
        IN      ULONG                       Index,
        IN      KEY_VALUE_INFORMATION_CLASS KeyValueInformationClass,
        OUT     PVOID                       KeyValueInformation,
        IN      ULONG                       Length,
        OUT     PULONG                      ResultLength
    )   PURE;

    STDMETHOD(SetValueKey)
    (   THIS_
        IN      PUNICODE_STRING     ValueName OPTIONAL,
        IN      ULONG               Type,
        IN      PVOID               Data,
        IN      ULONG               DataSize
    )   PURE;

    STDMETHOD(QueryRegistryValues)
    (   THIS_
        IN      PRTL_QUERY_REGISTRY_TABLE   QueryTable,
        IN      PVOID                       Context OPTIONAL
    )   PURE;

    STDMETHOD(NewSubKey)
    (
        OUT     IRegistryKey **     RegistrySubKey,
        IN      PUNKNOWN            OuterUnknown,
        IN      ACCESS_MASK         DesiredAccess,
        IN      PUNICODE_STRING     SubKeyName,
        IN      ULONG               CreateOptions,
        OUT     PULONG              Disposition     OPTIONAL
    )   PURE;

    STDMETHOD(DeleteKey)
    (   THIS
    )   PURE;
};

typedef IRegistryKey *PREGISTRYKEY;

typedef struct _PROPERTY_REQUEST PROPERTY_REQUEST, *PPROPERTY_REQUEST;

/*****************************************************************************
 * PPROPERTYHANDLER
 *****************************************************************************
 * Property handler function prototype.
 */
typedef 
NTSTATUS 
(*PPROPERTY_HANDLER)
(
    IN      PPROPERTY_REQUEST   PropertyRequest
);

/*****************************************************************************
 * PROPERTY_ITEM
 *****************************************************************************
 * Property table entry.
 */
typedef struct _PROPERTY_ITEM
{
    const GUID *        Set;
    ULONG               Id;
    ULONG               VerbSupport;
    PPROPERTY_HANDLER   Handler;
}
PROPERTY_ITEM, *PPROPERTY_ITEM;

/*****************************************************************************
 * PROPERTY_REQUEST
 *****************************************************************************
 * Property request submitted to a property handler.
 */
typedef struct _PROPERTY_REQUEST
{
    PVOID           Context;
    PPROPERTY_ITEM  PropertyItem;
    ULONG           Verb;
    ULONG           Node;
    ULONG           InstanceSize;
    PVOID           Instance;
    ULONG           ValueSize;
    PVOID           Value;
}
PROPERTY_REQUEST, *PPROPERTY_REQUEST;

/*****************************************************************************
 * Stop states for IMiniport::SetStopState()
 *****************************************************************************
 * Enumeration of states.
 */
enum
{
    StopStateNormal,
    StopStateQuery,
    StopStateStop
};

/*****************************************************************************
 * MINIPORT_PIN for IMiniport::GetDescription()
 *****************************************************************************
 * Description of a pin on the filter implemented by the miniport.
 */
typedef struct
{
    ULONG           DataRangesCount;
    PKSDATARANGE *  DataRanges;
    ULONG           Instances;
    KSPIN_DATAFLOW  DataFlow;
    ULONG           PropertyCount;
    PPROPERTY_ITEM  Properties;
    ULONG           PropertyItemSize;
    const GUID *    PinCategory;
    GUID *          PinName;
} 
MINIPORT_PIN, *PMINIPORT_PIN;

/*****************************************************************************
 * TOPOLOGY_CONNECTION for IMiniport::GetDescription()
 *****************************************************************************
 * Description of a node connection in the topology of the filter implemented
 * by the miniport.
 */
typedef struct
{
	ULONG	FromNode;
	ULONG	FromPin;
	ULONG	ToNode;
	ULONG	ToPin;
} 
MINIPORT_CONNECTION, *PMINIPORT_CONNECTION;

/*****************************************************************************
 * MINIPORT_DESCRIPTION for IMiniport::GetDescription()
 *****************************************************************************
 * Description of the of the filter implemented by the miniport, including 
 * pins, nodes, connections and properties.
 */
typedef struct
{
    ULONG                   PinCount;
    PMINIPORT_PIN           Pins;
    ULONG                   NodeCount;
    GUID *                  Nodes;
    GUID *                  NodeNames;
    ULONG                   ConnectionCount;
    PMINIPORT_CONNECTION    Connections;
    ULONG                   PropertyCount;
    PPROPERTY_ITEM          Properties;
    ULONG                   PropertyItemSize;
}
MINIPORT_DESCRIPTION, *PMINIPORT_DESCRIPTION;

/*****************************************************************************
 * MINIPORTTOPOLOGY_FILTERNODE for IMiniport::GetTopology()
 *****************************************************************************
 * The placeholder for the FromNode or ToNode fields in connections which
 * describe connections to the filter's pins.
 */
#define TOPOLOGY_FILTERNODE ((ULONG)-1)

/*****************************************************************************
 * IMiniport
 *****************************************************************************
 * Interface common to all miniports.
 */
DECLARE_INTERFACE_(IMiniport,IUnknown)
{
    STDMETHOD(SetStopState)
    (   THIS_
        IN      ULONG   StopState
    )   PURE;

    STDMETHOD(SetPowerState)
    (   THIS_
        IN      ULONG   PowerState
    )   PURE;

    STDMETHOD(GetDescription)
    (   THIS_
        OUT     PMINIPORT_DESCRIPTION * Description
    )   PURE;
};

typedef IMiniport *PMINIPORT;

/*****************************************************************************
 * IPort
 *****************************************************************************
 * Interface common to all port lower edges.
 */
DECLARE_INTERFACE_(IPort,IUnknown)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PVOID           Context1,
        IN      PVOID           Context2,
        IN      PUNKNOWN        UnknownMiniport,
        IN      PUNKNOWN        UnknownAdapter      OPTIONAL,
        IN      PRESOURCELIST   ResourceList
    )   PURE;

    STDMETHOD(GetDeviceProperty)
    (   THIS_
        IN      DEVICE_REGISTRY_PROPERTY    DeviceProperty,
        IN      ULONG                       BufferLength,
        OUT     PVOID                       PropertyBuffer,
        OUT     PULONG                      ResultLength
    )   PURE;

    STDMETHOD(NewRegistryKey)
    (   THIS_
        OUT     PREGISTRYKEY *      OutRegistryKey,
        IN      PUNKNOWN            OuterUnknown        OPTIONAL,
        IN      ULONG               RegistryKeyType,
        IN      ACCESS_MASK         DesiredAccess,
        IN      POBJECT_ATTRIBUTES  ObjectAttributes    OPTIONAL,
        IN      ULONG               CreateOptions       OPTIONAL,
        OUT     PULONG              Disposition         OPTIONAL
    )   PURE;
};

typedef IPort *PPORT;

/*****************************************************************************
 * IPortMidi
 *****************************************************************************
 * Interface for MIDI port lower edge.
 */
DECLARE_INTERFACE_(IPortMidi,IPort)
{
    STDMETHOD_(void,Notify)
    (   THIS_
        IN      PSERVICEGROUP   ServiceGroup    OPTIONAL
    )   PURE;
};

typedef IPortMidi *PPORTMIDI;

/*****************************************************************************
 * IMiniportMidiStream
 *****************************************************************************
 * Interface for MIDI miniport streams.
 */
DECLARE_INTERFACE_(IMiniportMidiStream,IUnknown)
{
    STDMETHOD(SetFormat)
    (   THIS_
        IN      PKSDATAFORMAT   DataFormat
    )   PURE;

    STDMETHOD(SetState)
    (   THIS_
        IN      KSSTATE     State
    )   PURE;

    STDMETHOD(Read)
    (   THIS_
        IN      PVOID       BufferAddress,
        IN      ULONG       BufferLength,
        OUT     PULONG      BytesRead
    )   PURE;

    STDMETHOD(Write)
    (   THIS_
        IN      PVOID       BufferAddress,
        IN      ULONG       BytesToWrite,
        OUT     PULONG      BytesWritten
    )   PURE;
};

typedef IMiniportMidiStream *PMINIPORTMIDISTREAM;

/*****************************************************************************
 * IMiniportMidi
 *****************************************************************************
 * Interface for MIDI miniports.
 */
DECLARE_INTERFACE_(IMiniportMidi,IMiniport)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PUNKNOWN        UnknownAdapter,
        IN      PRESOURCELIST   ResourceList,
        IN      PPORTMIDI       Port,
        OUT     PSERVICEGROUP * ServiceGroup
    )   PURE;

    STDMETHOD(NewStream)
    (   THIS_
        OUT     PMINIPORTMIDISTREAM *   Stream,
        IN      PUNKNOWN                OuterUnknown    OPTIONAL,
        IN      POOL_TYPE               PoolType,
        IN      ULONG                   Pin,
        IN      BOOLEAN                 Capture,
        IN      PKSDATAFORMAT           DataFormat,
        OUT     PSERVICEGROUP *         ServiceGroup
    )   PURE;

    STDMETHOD_(void,Service)
    (   THIS
    )   PURE;
};

typedef IMiniportMidi *PMINIPORTMIDI;

/*****************************************************************************
 * IPortTopology
 *****************************************************************************
 * Interface for topology port lower edge.
 */
DECLARE_INTERFACE_(IPortTopology,IPort)
{
    STDMETHOD_(void,NotifyControlChanges)
    (   THIS
    )   PURE;
};

typedef IPortTopology *PPORTTOPOLOGY;

/*****************************************************************************
 * IMiniportTopology
 *****************************************************************************
 * Interface for topology miniports.
 */
DECLARE_INTERFACE_(IMiniportTopology,IMiniport)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PUNKNOWN                UnknownAdapter,
	    IN	 	PRESOURCELIST           ResourceList,
        IN      PPORTTOPOLOGY           Port
    )   PURE;
 
    STDMETHOD(ReadControlChanges)
    (   THIS_
	    IN		ULONG			        Requested,
	    OUT		PULONG      			Delivered,
	    OUT		PULONG 		        	Buffer
    )   PURE;

    STDMETHOD(FlushControlChanges)
    (   THIS
    )   PURE;
};

typedef IMiniportTopology *PMINIPORTTOPOLOGY;

/*****************************************************************************
 * IPortWaveCyclic
 *****************************************************************************
 * Interface for cyclic wave port lower edge.
 */
DECLARE_INTERFACE_(IPortWaveCyclic,IPort)
{
    STDMETHOD_(void,Notify)
    (   THIS_
        IN      PSERVICEGROUP   ServiceGroup
    )   PURE;

    STDMETHOD(NewSlaveDmaChannel)
    (   THIS_
        OUT     PDMACHANNEL *   DmaChannel,
        IN      PUNKNOWN        OuterUnknown,
        IN      PRESOURCELIST   ResourceList,
        IN      ULONG           DmaIndex,
        IN      ULONG           MaximumLength,
        IN      BOOLEAN         DemandMode,
        IN      DMA_SPEED       DmaSpeed
    )   PURE;

    STDMETHOD(NewMasterDmaChannel)
    (   THIS_
        OUT     PDMACHANNEL *   DmaChannel,
        IN      PUNKNOWN        OuterUnknown,
        IN      PRESOURCELIST   ResourceList    OPTIONAL,
        IN      ULONG           MaximumLength,
        IN      BOOLEAN         Dma32BitAddresses,
        IN      BOOLEAN         Dma64BitAddresses,
        IN      DMA_SPEED       DmaSpeed
    )   PURE;
};

typedef IPortWaveCyclic *PPORTWAVECYCLIC;

/*****************************************************************************
 * IMiniportWaveCyclicStream
 *****************************************************************************
 * Interface for cyclic wave miniport streams.
 */
DECLARE_INTERFACE_(IMiniportWaveCyclicStream,IUnknown)
{
    STDMETHOD(SetFormat)
    (   THIS_
        IN      PKSDATAFORMAT   DataFormat
    )   PURE;

    STDMETHOD_(ULONG,SetNotificationFreq)
    (   THIS_
        IN      ULONG           Interval
    )   PURE;

    STDMETHOD(SetState)
    (   THIS_
        IN      KSSTATE         State
    )   PURE;

    STDMETHOD(GetPosition)
    (   THIS_
        OUT     PULONG          Position
    )   PURE;
};

typedef IMiniportWaveCyclicStream *PMINIPORTWAVECYCLICSTREAM;

/*****************************************************************************
 * IMiniportWaveCyclic
 *****************************************************************************
 * Interface for cyclic wave miniports.
 */
DECLARE_INTERFACE_(IMiniportWaveCyclic,IMiniport)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PUNKNOWN        UnknownAdapter,
        IN      PRESOURCELIST   ResourceList,
        IN      PPORTWAVECYCLIC Port
    )   PURE;

    STDMETHOD(NewStream)
    (   THIS_
        OUT     PMINIPORTWAVECYCLICSTREAM * Stream,
        IN      PUNKNOWN                    OuterUnknown    OPTIONAL,
        IN      POOL_TYPE                   PoolType,
        IN      ULONG                       Pin,
        IN      BOOLEAN                     Capture,
        IN      PKSDATAFORMAT               DataFormat,
        OUT     PDMACHANNEL *               DmaChannel,
        OUT     PSERVICEGROUP *             ServiceGroup
    )   PURE;
};

typedef IMiniportWaveCyclic *PMINIPORTWAVECYCLIC;

/*****************************************************************************
 * IPortWavePci
 *****************************************************************************
 * Interface for PCI wave port lower edge.
 */
DECLARE_INTERFACE_(IPortWavePci,IPort)
{
    STDMETHOD_(void,Notify)
    (   THIS_
        IN      PSERVICEGROUP       ServiceGroup
    )   PURE;

    STDMETHOD(NewMasterDmaChannel)
    (   THIS_
        OUT     PDMACHANNEL *       OutDmaChannel,
        IN      PUNKNOWN            OuterUnknown    OPTIONAL,
        IN      POOL_TYPE           PoolType,
        IN      PRESOURCELIST       ResourceList    OPTIONAL,
        IN      BOOLEAN             ScatterGather,
        IN      BOOLEAN             Dma32BitAddresses,
        IN      BOOLEAN             Dma64BitAddresses,
        IN      BOOLEAN             IgnoreCount,
        IN      DMA_WIDTH           DmaWidth,
        IN      DMA_SPEED           DmaSpeed,
        IN      ULONG               MaximumLength,
        IN      ULONG               DmaPort
    )   PURE;
};

typedef IPortWavePci *PPORTWAVEPCI;

/*****************************************************************************
 * IPortWavePciStream
 *****************************************************************************
 * Interface for PCI wave port pin lower edge.
 */
DECLARE_INTERFACE_(IPortWavePciStream,IUnknown)
{
    STDMETHOD(GetMapping)
    (   THIS_
        IN      PVOID               Tag,
        OUT     PPHYSICAL_ADDRESS   PhysicalAddress,
        OUT     PVOID *             VirtualAddress,
        OUT     PULONG              ByteCount,
        OUT     PULONG              Flags
    )   PURE;

    STDMETHOD(ReleaseMapping)
    (   THIS_
        IN      PVOID               Tag
    )   PURE;

    STDMETHOD(TerminatePacket)
    (   THIS
    )   PURE;
};

typedef IPortWavePciStream *PPORTWAVEPCISTREAM;

/*****************************************************************************
 * IMiniportWavePciStream
 *****************************************************************************
 * Interface for PCI wave miniport streams.
 */
DECLARE_INTERFACE_(IMiniportWavePciStream,IUnknown)
{
    STDMETHOD(SetFormat)
    (   THIS_
        IN      PKSDATAFORMAT   DataFormat
    )   PURE;

    STDMETHOD(SetState)
    (   THIS_
        IN      KSSTATE         State
    )   PURE;

    STDMETHOD(GetPosition)
    (   THIS_
        OUT     PULONGLONG      Position
    )   PURE;

    STDMETHOD(RevokeMappings)
    (   THIS_
        IN      PVOID           FirstTag,
        IN      PVOID           LastTag,
        OUT     PULONG          MappingsRevoked
    )   PURE;

    STDMETHOD_(void,MappingAvailable)
    (   THIS
    )   PURE;

    STDMETHOD_(void,Service)
    (   THIS
    )   PURE;
};

typedef IMiniportWavePciStream *PMINIPORTWAVEPCISTREAM;

/*****************************************************************************
 * IMiniportWavePci
 *****************************************************************************
 * Interface for PCI wave miniports.
 */
DECLARE_INTERFACE_(IMiniportWavePci,IMiniport)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PUNKNOWN            UnknownAdapter,
        IN      PRESOURCELIST       ResourceList,
        IN      PPORTWAVEPCI        Port,
        OUT     PSERVICEGROUP *     ServiceGroup
    )   PURE;

    STDMETHOD(NewStream)
    (   THIS_
        OUT     PMINIPORTWAVEPCISTREAM *    Stream,
        IN      PUNKNOWN                    OuterUnknown    OPTIONAL,
        IN      POOL_TYPE                   PoolType,
        IN      PPORTWAVEPCISTREAM          PortStream,
        IN      ULONG                       Pin,
        IN      BOOLEAN                     Capture,
        IN      PKSDATAFORMAT               DataFormat,
        OUT     PDMACHANNEL *               DmaChannel,
        OUT     PSERVICEGROUP *             ServiceGroup
    )   PURE;

    STDMETHOD_(void,Service)
    (   THIS
    )   PURE;
};

typedef IMiniportWavePci *PMINIPORTWAVEPCI;

/*****************************************************************************
 * IPortWavetable
 *****************************************************************************
 * Interface for wavetable port lower edge.
 */
DECLARE_INTERFACE_(IPortWavetable,IPort)
{
};

typedef IPortWavetable *PPORTWAVETABLE;

/*****************************************************************************
 * IPortWavetableVoice
 *****************************************************************************
 * Interface for wavetable port voice lower edge.
 */
DECLARE_INTERFACE_(IPortWavetableVoice,IUnknown)
{
    STDMETHOD(ReleaseComplete)
    (   THIS
	)   PURE;
};

typedef IPortWavetableVoice *PPORTWAVETABLEVOICE;

/*****************************************************************************
 * IMiniportWavetableVoice
 *****************************************************************************
 * Interface for wavetable miniport voices.
 */
DECLARE_INTERFACE_(IMiniportWavetableVoice,IUnknown)
{
    STDMETHOD(SetState)
    (   THIS_
        IN      KSSTATE         State
    )   PURE;

    STDMETHOD(EnvelopeRelease)
    (   THIS_
        OUT     PULONG          Duration
	)   PURE;

    STDMETHOD(GetPosition)
    (   THIS_
        OUT     PULONG          Position
    )   PURE;
};

typedef IMiniportWavetableVoice *PMINIPORTWAVETABLEVOICE;

/*****************************************************************************
 * IMiniportWavetable
 *****************************************************************************
 * Interface for wavetable miniports.
 */
DECLARE_INTERFACE_(IMiniportWavetable,IMiniport)
{
    STDMETHOD(Init)
    (   THIS_
        IN      PUNKNOWN        UnknownAdapter,
        IN      PRESOURCELIST   ResourceList,
        IN      PPORTWAVETABLE  Port
    )   PURE;

    STDMETHOD(NewVoice)
    (   THIS_
        OUT     PMINIPORTWAVETABLEVOICE *   Voice,
        IN      PUNKNOWN                    OuterUnknown    OPTIONAL,
        IN      POOL_TYPE                   PoolType,
        IN      PPORTWAVETABLEVOICE         PortVoice
    )   PURE;

    STDMETHOD(FindWave)
    (   THIS_
        IN      PKSIDENTIFIER   Identifier,
        OUT     PVOID *         Handle,
        OUT     PULONG          Size        OPTIONAL,
        OUT     PKSDATAFORMAT   Format      OPTIONAL,
        OUT     PBOOL           Looped      OPTIONAL,
        OUT     PULONG          LoopPoint   OPTIONAL,
        OUT     BOOL *          InROM       OPTIONAL
    )   PURE;

    STDMETHOD(CreateWave)
    (   THIS_
        IN      PKSIDENTIFIER   Identifier,
        IN      ULONG           Size,
        IN      PKSDATAFORMAT   Format,
        IN      BOOL            Looped,
        IN      ULONG           LoopPoint,
        OUT     PVOID *         Handle
    )   PURE;

    STDMETHOD(DeleteWave)
    (   THIS_
        IN      PVOID           Handle
    )   PURE;

    STDMETHOD(WriteWave)
    (   THIS_
        IN      PVOID           Handle,
        IN      PVOID           BufferAddress,
        IN      ULONG           ByteOffset,
        IN      ULONG           Length
    )   PURE;
};

typedef IMiniportWavetable *PMINIPORTWAVETABLE;





/*****************************************************************************
 * Functions.
 */

/*****************************************************************************
 * PFNADDDEVICE
 *****************************************************************************
 * Type for add device callback.
 */
typedef
NTSTATUS
(*PFNADDDEVICE)
(
    IN      PVOID   Context1,
    IN      PVOID   Context2
);

/*****************************************************************************
 * PFNSTARTDEVICE
 *****************************************************************************
 * Type for start device callback.
 */
typedef
NTSTATUS
(*PFNSTARTDEVICE)
(
    IN      PVOID           Context1,
    IN      PVOID           Context2,
    IN      PRESOURCELIST   ResourceList
);

/*****************************************************************************
 * InitializeAdapterDriver()
 *****************************************************************************
 * Initializes an adapter driver.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
InitializeAdapterDriver
(
    IN      PVOID           Context1,
    IN      PVOID           Context2,
    IN      PFNADDDEVICE    AddDevice
);

/*****************************************************************************
 * AddAdapterDevice()
 *****************************************************************************
 * Adds an adapter device.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
AddAdapterDevice
(
    IN      PVOID           Context1,
    IN      PVOID           Context2,
    IN      PFNSTARTDEVICE  StartDevice,
    IN      ULONG           MaxSubdevices
);

/*****************************************************************************
 * RegisterSubdevice()
 *****************************************************************************
 * Registers a subdevice.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
RegisterSubdevice
(
    IN      PVOID       Context1,
    IN      PVOID       Context2,
    IN      PWCHAR      Name,
    IN      PUNKNOWN    Unknown
);

/*****************************************************************************
 * RegisterPhysicalConnection()
 *****************************************************************************
 * Registers a physical connection between subdevices.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
RegisterPhysicalConnection
(
    IN      PVOID       Context1,
    IN      PVOID       Context2,
    IN      PUNKNOWN    FromUnknown,
    IN      ULONG       FromPin,
    IN      PUNKNOWN    ToUnknown,
    IN      ULONG       ToPin
);

/*****************************************************************************
 * RegisterPhysicalConnectionToExternal()
 *****************************************************************************
 * Registers a physical connection from a subdevice to an external device.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
RegisterPhysicalConnectionToExternal
(
    IN      PVOID           Context1,
    IN      PVOID           Context2,
    IN      PUNKNOWN        FromUnknown,
    IN      ULONG           FromPin,
    IN      PUNICODE_STRING ToString,
    IN      ULONG           ToPin
);

/*****************************************************************************
 * RegisterPhysicalConnectionFromExternal()
 *****************************************************************************
 * Registers a physical connection to a subdevice from an external device.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
RegisterPhysicalConnectionFromExternal
(
    IN      PVOID           Context1,
    IN      PVOID           Context2,
    IN      PUNICODE_STRING FromString,
    IN      ULONG           FromPin,
    IN      PUNKNOWN        ToUnknown,
    IN      ULONG           ToPin
);

/*****************************************************************************
 * NewPort()
 *****************************************************************************
 * Creates an instance of a port driver.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewPort
(
    OUT     PPORT *     OutPort,
    IN      REFCLSID    ClassID
);

/*****************************************************************************
 * NewMiniport()
 *****************************************************************************
 * Creates an instance of a system-supplied miniport driver.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewMiniport
(
    OUT     PMINIPORT * OutMiniPort,
    IN      REFCLSID    ClassID
);

/*****************************************************************************
 * CompletePendingPropertyRequest()
 *****************************************************************************
 * Completes a pending property request.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
CompletePendingPropertyRequest
(
    IN      PPROPERTY_REQUEST   PropertyRequest,
    IN      NTSTATUS            NtStatus
);

/*****************************************************************************
 * WIN95COMPAT_ReadPortUChar()
 *****************************************************************************
 * Reads a byte from a port.
 */
PORTCLASSAPI
UCHAR
NTAPI
WIN95COMPAT_ReadPortUChar
(
    IN      PUCHAR  Port
);

/*****************************************************************************
 * WIN95COMPAT_WritePortUChar()
 *****************************************************************************
 * Writes a byte to a port.
 */
PORTCLASSAPI
VOID
NTAPI
WIN95COMPAT_WritePortUChar
(
    IN      PUCHAR  Port,
    IN      UCHAR   Value
);

/*****************************************************************************
 * WIN95COMPAT_ReadPortUShort()
 *****************************************************************************
 * Reads a short from a port.
 */
PORTCLASSAPI
USHORT
NTAPI
WIN95COMPAT_ReadPortUShort
(
    IN      PUSHORT Port
);

/*****************************************************************************
 * WIN95COMPAT_WritePortUShort()
 *****************************************************************************
 * Writes a short to a port.
 */
PORTCLASSAPI
VOID
NTAPI
WIN95COMPAT_WritePortUShort
(
    IN      PUSHORT Port,
    IN      USHORT  Value
);

/*****************************************************************************
 * PcAllocMem()
 *****************************************************************************
 * Allocates memory.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
PcAllocMem
(
    IN      ULONG   Bytes,
    IN      BOOLEAN Paged,
    IN      ULONG   Tag,
    OUT     PVOID * Memory
);

/*****************************************************************************
 * PcFreeMem()
 *****************************************************************************
 * Frees memory.
 */
PORTCLASSAPI
VOID
NTAPI
PcFreeMem
(
    IN      PVOID   Memory
);

/*****************************************************************************
 * PcInterlockedIncrement()
 *****************************************************************************
 * Increments a long.
 */
PORTCLASSAPI
LONG
NTAPI
PcInterlockedIncrement
(
    IN      PLONG   Long
);

/*****************************************************************************
 * PcInterlockedDecrement()
 *****************************************************************************
 * Decrements a long.
 */
PORTCLASSAPI
LONG
NTAPI
PcInterlockedDecrement
(
    IN      PLONG   Long
);

/*****************************************************************************
 * PcInterlockedExchange()
 *****************************************************************************
 * Performs an exchange of two longs.
 */
PORTCLASSAPI
LONG
NTAPI
PcInterlockedExchange
(
    IN OUT  PLONG   Target,
    IN      LONG    Value
);

/*****************************************************************************
 * GetTimeInterval
 *****************************************************************************
 * Gets the system time interval
 */
PORTCLASSAPI
ULONGLONG
NTAPI
GetTimeInterval
(
    IN  ULONGLONG   Since
);

#define GTI_SECONDS(t)      (ULONGLONG(t)*10000000)
#define GTI_MILLISECONDS(t) (ULONGLONG(t)*10000)
#define GTI_MICROSECONDS(t) (ULONGLONG(t)*10)

/*****************************************************************************
 * NewResourceList()
 *****************************************************************************
 * Creates and initializes a resource list.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewResourceList
(
    OUT     PRESOURCELIST *     OutResourceList,
    IN      PUNKNOWN            OuterUnknown            OPTIONAL,
    IN      POOL_TYPE           PoolType,
    IN      PCM_RESOURCE_LIST   TranslatedResources,
    IN      PCM_RESOURCE_LIST   UntranslatedResources
);

/*****************************************************************************
 * NewResourceSublist()
 *****************************************************************************
 * Creates and initializes an empty resource list derived from another
 * resource list.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewResourceSublist
(
    OUT     PRESOURCELIST *     OutResourceList,
    IN      PUNKNOWN            OuterUnknown            OPTIONAL,
    IN      POOL_TYPE           PoolType,
    IN      PRESOURCELIST       ParentList,
    IN      ULONG               MaximumEntries
);

/*****************************************************************************
 * NewInterruptSync()
 *****************************************************************************
 * Creates and initializes an interrupt-level synchronization object.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewInterruptSync
(
    OUT     PINTERRUPTSYNC *        OutInterruptSync,
    IN      PUNKNOWN                OuterUnknown            OPTIONAL,
    IN      PRESOURCELIST           ResourceList,
    IN      ULONG                   ResourceIndex,
    IN      PINTERRUPTSYNCROUTINE   ServiceRoutine,
    IN      PVOID                   StaticContext           OPTIONAL
);

/*****************************************************************************
 * NewAccessSync()
 *****************************************************************************
 * Creates and initializes an access synchronization object.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewAccessSync
(
    OUT     PACCESSSYNC *       OutAccessSync,
    IN      PUNKNOWN            OuterUnknown            OPTIONAL,
    IN      KIRQL               MaxIrql
);

/*****************************************************************************
 * NewServiceGroup()
 *****************************************************************************
 * Creates and initializes a service group object.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewServiceGroup
(
    OUT     PSERVICEGROUP *     OutServiceGroup,
    IN      PUNKNOWN            OuterUnknown            OPTIONAL
);

/*****************************************************************************
 * NewRegistryKey()
 *****************************************************************************
 * Creates and initializes a registry key object.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
NewRegistryKey
(
    OUT     PREGISTRYKEY *      OutRegistryKey,
    IN      PUNKNOWN            OuterUnknown        OPTIONAL,
    IN      ULONG               RegistryKeyType,
    IN      ACCESS_MASK         DesiredAccess,
    IN      PVOID               DeviceObject        OPTIONAL,
    IN      PVOID               SubDevice           OPTIONAL,
    IN      POBJECT_ATTRIBUTES  ObjectAttributes    OPTIONAL,
    IN      ULONG               CreateOptions       OPTIONAL,
    OUT     PULONG              Disposition         OPTIONAL
);

/*****************************************************************************
 * RegistryKeyType for NewRegistryKey()
 *****************************************************************************
 * Enumeration of key types.
 */
enum
{
    GeneralRegistryKey,     // ObjectAttributes and CreateOptions are req'd.
    DeviceRegistryKey,      // Device Object is required
    DriverRegistryKey,      // Device Object is required
    HwProfileRegistryKey,   // Device Object is required
    DeviceInterfaceRegistryKey  // Device Object and SubDevice are required
};

/*****************************************************************************
 * GetDeviceProperty()
 *****************************************************************************
 * This returns the requested device property from the registry.
 */
PORTCLASSAPI
NTSTATUS
NTAPI
GetDeviceProperty
(
    IN      PVOID                       DeviceObject,
    IN      DEVICE_REGISTRY_PROPERTY    DeviceProperty,
    IN      ULONG                       BufferLength,
    OUT     PVOID                       PropertyBuffer,
    OUT     PULONG                      ResultLength
);

#endif
