#include <windows.h>
#include "resource.h"
#include <wtypes.h>
#include <stdlib.h>
#include "hidsdi.h"
#include  "hid.h"



#define INPUT_BUTTON    1
#define INPUT_VALUE     2
#define OUTPUT_BUTTON   3
#define OUTPUT_VALUE    4
#define FEATURE_BUTTON  5
#define FEATURE_VALUE   6
#define HID_CAPS        7
#define DEVICE_ATTRIBUTES 8




#define MAX_LB_ITEMS 200

#define MAX_WRITE_ELEMENTS 100



#define CONTROL_COUNT 9
#define MAX_LABEL 128
#define MAX_VALUE 128

struct rWriteDataStruct_type
{
        char szLabel[MAX_LABEL];
        char szValue[MAX_VALUE];
};

typedef struct rWriteDataStruct_type rWriteDataStruct;
typedef rWriteDataStruct *prWriteDataStruct;

struct rGetWriteDataParams_type
{
        prWriteDataStruct prItems;
        int iCount;
};
typedef struct rGetWriteDataParams_type rGetWriteDataParams;
typedef rGetWriteDataParams *prGetWriteDataParams;






HINSTANCE hGInstance; //global application instance handle

VOID vReadDataFromControls(HWND hDlg,prWriteDataStruct prData,int iOffset,int iCount);
BOOL CALLBACK bGetDataDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK bMainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
VOID vLoadItemTypes(HWND hItemTypes);
BOOL CALLBACK bGetDataDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
BOOL bGetWriteData(prWriteDataStruct,int iCount,HWND hParent);
VOID vLoadDevices(HWND hDeviceCombo);
VOID vDisplayInputButtons(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayInputValues(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayOutputButtons(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayOutputValues(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayFeatureButtons(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayFeatureValues(PHID_DEVICE pDevice,HWND hControl);
VOID vWriteDataToControls(HWND hDlg,prWriteDataStruct prData,int iOffset,int iCount);
VOID vDisplayButtonAttributes(PHIDP_BUTTON_CAPS pButton,HWND hControl);
VOID vDisplayValueAttributes(PHIDP_VALUE_CAPS pValue,HWND hControl);
VOID vDisplayDeviceCaps(PHID_DEVICE pDevice,HWND hControl);
VOID vDisplayDeviceAttributes(PHID_DEVICE pDevice,HWND hControl);
BOOL CALLBACK bReadDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
int iPrepareWriteFields(PHID_DEVICE pDevice,rWriteDataStruct rWriteData[],int iMaxElements);
BOOL bParseWriteData(PHID_DEVICE pDevice,rWriteDataStruct rWriteData[],int iCount,int *piErrorLine);
BOOL bSetButtonUsages(PHID_DATA pCap,char *pszInputString);


VOID
ReportToString(
   PHID_DATA pData,
   PCHAR szLabel,
   PCHAR szValue
   );




/*******************************
*WinMain: Windows Entry point  *
********************************/
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR     lpCmdLine,
                   int       nCmdShow)
{
    hGInstance=hInstance;

    if(DialogBox(hInstance,"MAIN_DIALOG",NULL,(DLGPROC)bMainDlgProc)==-1)
          MessageBox(NULL,"Unable to create root dialog!","DialogBox failure",MB_ICONSTOP);

        return 0;
}


#define MAX_OUTPUT_ELEMENTS 50
/**************************************************
 * Main Dialog proc                               *
 **************************************************/

BOOL CALLBACK bMainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  int iIndex;
  int iCount;
  static HWND hComboCtrl;
  char szTempBuff[128];
  PHID_DEVICE pDevice;
  PHIDP_BUTTON_CAPS pButtonCaps;
  PHIDP_VALUE_CAPS pValueCaps;
  int iErrorLine;
  static rWriteDataStruct rWriteData[50];
  int iItemType;
  switch(message)
  {
    case WM_INITDIALOG:
                vLoadDevices(GetDlgItem(hDlg,IDC_DEVICES));
                vLoadItemTypes(GetDlgItem(hDlg,IDC_TYPE));
                PostMessage(hDlg,WM_COMMAND,IDC_DEVICES+(CBN_SELCHANGE<<16),(LONG)GetDlgItem(hDlg,IDC_DEVICES));

                                  strcpy(rWriteData[0].szLabel,"Label1");
                                  strcpy(rWriteData[1].szLabel,"Label2");
                                  strcpy(rWriteData[2].szLabel,"Label3");
                                  strcpy(rWriteData[3].szLabel,"Label4");
                                  strcpy(rWriteData[4].szLabel,"Label5");
                                  strcpy(rWriteData[5].szLabel,"Label6");
                                  strcpy(rWriteData[6].szLabel,"Label7");
                                  strcpy(rWriteData[7].szLabel,"Label8");
                                  strcpy(rWriteData[8].szLabel,"Label9");
                                  strcpy(rWriteData[9].szLabel,"Label10");
                                  strcpy(rWriteData[10].szLabel,"Label11");
                                  strcpy(rWriteData[11].szLabel,"Label12");
                                 /* strcpy(rWriteData[0].szValue,"Value1");
                                  strcpy(rWriteData[1].szValue,"Value2");
                                  strcpy(rWriteData[2].szValue,"Value3");
                                  strcpy(rWriteData[3].szValue,"Value4");
                              strcpy(rWriteData[4].szValue,"Value5");
                                  strcpy(rWriteData[5].szValue,"Value6");
                                  strcpy(rWriteData[6].szValue,"Value7");
                                  strcpy(rWriteData[7].szValue,"Value8");
                                  strcpy(rWriteData[8].szValue,"Value9");
                                  strcpy(rWriteData[9].szValue,"Value10");
                              strcpy(rWriteData[10].szValue,"Value11");
                                  strcpy(rWriteData[11].szValue,"Value12"); */

        break; /*end WM_INITDIALOG case*/

        case WM_COMMAND:
                switch(LOWORD(wParam))
                {
                  case IDC_READ:
                    pDevice=NULL;
                    iIndex=(int)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETCURSEL,0,0);
                    if(iIndex!=-1)
                    {
                      pDevice=(PHID_DEVICE)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETITEMDATA,iIndex,0);
                    }
                    if(NULL!=pDevice)
                    {
                      iIndex=DialogBoxParam(hGInstance,"READDATA",hDlg,bReadDlgProc,(LONG)pDevice);
                    } /*end if pDevice!NULL*/

                  break;

                                          case IDC_WRITE:

                    pDevice=NULL;
                    iIndex=(int)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETCURSEL,0,0);
                    if(iIndex!=-1)
                    {
                      pDevice=(PHID_DEVICE)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETITEMDATA,iIndex,0);
                    }
                    if(NULL!=pDevice)
                    {
                      iCount=iPrepareWriteFields(pDevice,rWriteData,MAX_OUTPUT_ELEMENTS);
                                                if(bGetWriteData(rWriteData,iCount,hDlg))
                      {
                        if(bParseWriteData(pDevice,rWriteData,iCount,&iErrorLine))
                          Write(pDevice);
                        else
                        {
                          wsprintf(szTempBuff,"Unable to parse line %x of output data",iErrorLine);
                          MessageBox(hDlg,szTempBuff,"Data Error",MB_ICONEXCLAMATION);
                        }
                      } /*end if bGetWriteData returned TRUE*/
                    } /*end if pDevice!NULL*/
                                          break; /*end case IDC_WRITE*/


                  case IDC_DEVICES:
                    switch(HIWORD(wParam))
                    {
                      case CBN_SELCHANGE:
                        PostMessage(hDlg,WM_COMMAND,IDC_TYPE+(CBN_SELCHANGE<<16),(LONG)GetDlgItem(hDlg,IDC_TYPE));
                      break;
                    } //end switch HIWORD wParam
                  break;

                  case IDC_TYPE:
                    switch(HIWORD(wParam))
                          {
                            case CBN_SELCHANGE:
                                        pDevice=NULL;
                                        iIndex=SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETCURSEL,0,0);
                                        if(iIndex!=-1)
                                          pDevice=(PHID_DEVICE)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETITEMDATA,iIndex,0);
                                        iIndex=SendDlgItemMessage(hDlg,IDC_TYPE,CB_GETCURSEL,0,0);
                                        iItemType=SendDlgItemMessage(hDlg,IDC_TYPE,CB_GETITEMDATA,iIndex,0);
                                        if(pDevice==NULL)
                                        {
                                                SendDlgItemMessage(hDlg,IDC_ITEMS,LB_RESETCONTENT,0,0);
                                                SendDlgItemMessage(hDlg,IDC_ATTRIBUTES,LB_RESETCONTENT,0,0);
                                        } /*end if no device selected*/
                                        else
                                        {
                                          switch(iItemType)
                                          {
                                            case INPUT_BUTTON:
                                                  vDisplayInputButtons(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;

                                            case INPUT_VALUE:
                                                  vDisplayInputValues(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;

                                            case OUTPUT_BUTTON:
                                                  vDisplayOutputButtons(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;

                                            case OUTPUT_VALUE:
                                                  vDisplayOutputValues(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;

                                            case FEATURE_BUTTON:
                                                  vDisplayFeatureButtons(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;

                                            case FEATURE_VALUE:
                                                  vDisplayFeatureValues(pDevice,GetDlgItem(hDlg,IDC_ITEMS));
                                            break;
                                          } /*end switch iItemType*/
                                          PostMessage(hDlg,WM_COMMAND,IDC_ITEMS+(LBN_SELCHANGE<<16),(LONG)GetDlgItem(hDlg,IDC_ITEMS));
                                        } /*end else device is !null*/
                            break; //case CBN_SELCHANGE
                          } //end switch HIWORD wParam
                  break; //case IDC_TYPE control

                  case IDC_ITEMS:
                          switch(HIWORD(wParam))
                          {
                            case LBN_SELCHANGE:
                                        iItemType=0;
                                        iIndex=SendDlgItemMessage(hDlg,IDC_TYPE,CB_GETCURSEL,0,0);
                                        if(iIndex!=-1)
                                                iItemType=(int)SendDlgItemMessage(hDlg,IDC_TYPE,CB_GETITEMDATA,iIndex,0);
                                        iIndex=SendDlgItemMessage(hDlg,IDC_ITEMS,LB_GETCURSEL,0,0);
                                        switch(iItemType)
                                        {
                                          case INPUT_BUTTON:
                                          case OUTPUT_BUTTON:
                                          case FEATURE_BUTTON:
                                              pButtonCaps=NULL;
                                                  if(iIndex!=-1)
                                                          pButtonCaps=(PHIDP_BUTTON_CAPS)SendDlgItemMessage(hDlg,IDC_ITEMS,LB_GETITEMDATA,iIndex,0);
                                                  if(pButtonCaps!=NULL)
                                                          vDisplayButtonAttributes(pButtonCaps,GetDlgItem(hDlg,IDC_ATTRIBUTES));
                                                  else
                                                          SendDlgItemMessage(hDlg,IDC_ATTRIBUTES,LB_RESETCONTENT,0,0);
                                          break;


                                          case INPUT_VALUE:
                                          case OUTPUT_VALUE:
                                          case FEATURE_VALUE:
                                                  pValueCaps=NULL;
                                                  if(iIndex!=-1)
                                                          pValueCaps=(PHIDP_VALUE_CAPS)SendDlgItemMessage(hDlg,IDC_ITEMS,LB_GETITEMDATA,iIndex,0);
                                                  if(pValueCaps!=NULL)
                                                          vDisplayValueAttributes(pValueCaps,GetDlgItem(hDlg,IDC_ATTRIBUTES));
                                                  else
                                                          SendDlgItemMessage(hDlg,IDC_ATTRIBUTES,LB_RESETCONTENT,0,0);

                                          break;

                                          case HID_CAPS:
                                                  pDevice=NULL;
                                                                                                                          pDevice=NULL;
                                                                                                                          SendDlgItemMessage(hDlg,IDC_ITEMS,LB_RESETCONTENT,0,0);
                                                  iIndex=(int)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETCURSEL,0,0);
                                                  if(iIndex!=-1)
                                                          pDevice=(PHID_DEVICE)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETITEMDATA,iIndex,0);
                                                  if(pDevice!=NULL)
                                                          vDisplayDeviceCaps(pDevice,GetDlgItem(hDlg,IDC_ATTRIBUTES));
                                          break;

                                          case DEVICE_ATTRIBUTES:
                                          {
                                                                                                                          SendDlgItemMessage(hDlg,IDC_ITEMS,LB_RESETCONTENT,0,0);
                                                  iIndex=(int)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETCURSEL,0,0);
                                                  if(iIndex!=-1)
                                                          pDevice=(PHID_DEVICE)SendDlgItemMessage(hDlg,IDC_DEVICES,CB_GETITEMDATA,iIndex,0);
                                                  if(pDevice!=NULL)
                                                          vDisplayDeviceAttributes(pDevice,GetDlgItem(hDlg,IDC_ATTRIBUTES));
                                          }
                                          break;

                                        } /*end switch iItemType*/


                                break; /*end case LBN_SELCHANGE in IDC_ITEMS*/

                          } /*end switch HIWORD wParam*/


                  break; /*case IDC_ITEMS*/


                  case IDC_ABOUT:
                          MessageBox(hDlg,"Sample HID client Application.  Microsoft Corp \nCopyright (C) 1997","About HClient",MB_ICONINFORMATION);

                  break;

                  case IDOK:
          case IDCANCEL:
                          //set to non-diag mode here!
                          EndDialog(hDlg,0);
                  break;

                } /*end switch wParam*/


        break;

  } /*end switch message*/
  return FALSE;

} /*end MainDlgProc*/


BOOL bParseWriteData(PHID_DEVICE pDevice,rWriteDataStruct rWriteData[],int iCount,int *piErrorLine)
{
  int iCap;
  PHID_DATA pOutputWalk;
  BOOL bNoError=TRUE;

  pOutputWalk=pDevice->OutputData;
  for(iCap=0;(iCap<iCount)&bNoError;iCap++)
  {
    if(!pOutputWalk->IsButtonData)
    {
      pOutputWalk->ValueData.Value=atol(rWriteData[iCap].szValue);
    } /*end if it's a value cap*/
    else
    {
      if(!bSetButtonUsages(pOutputWalk,rWriteData[iCap].szValue))
      {
        *piErrorLine=iCap;
        bNoError=FALSE;
      } /*end if unable to parse user input*/

    } /*end else it's a button cap*/
    pOutputWalk++;
  } /*end cap for loop*/
  return bNoError;
} /*end function bParseWriteData*/

BOOL bSetButtonUsages(PHID_DATA pCap,char *pszInputString)
{
  char szTempString[128];
  char *pszDelimiter=" ";
  char *pszToken;
  int iLoop;
  PUSAGE pUsageWalk;
  BOOL bNoError=TRUE;


  strcpy(szTempString,pszInputString);
  pszToken=strtok(szTempString,pszDelimiter);
  pUsageWalk=pCap->ButtonData.Usages;
  memset(pUsageWalk,0,pCap->ButtonData.MaxUsageLength);
  for(iLoop=0;((ULONG)iLoop<pCap->ButtonData.MaxUsageLength)&&(pszToken!=NULL)&&bNoError;iLoop++)
  {
    *pUsageWalk=atoi(pszToken);

    pszToken=strtok(NULL,pszDelimiter);
    pUsageWalk++;
  } /*end for*/

  return bNoError;
} /*end function bSetButtonUsages*/



int iPrepareWriteFields(PHID_DEVICE pDevice,rWriteDataStruct rWriteData[],int iMaxElements)
{
  int i;
  PHID_DATA pOutputWalk;
  char szTempBuff[256];

  pOutputWalk=pDevice->OutputData;

  for(i=0;(i<iMaxElements)&&((unsigned)i<pDevice->OutputDataLength);i++)
  {
    if(!pOutputWalk->IsButtonData)
    {
      wsprintf(szTempBuff,"ValueCap; UsagePage=0x%x, Usage=0x%x",pOutputWalk->UsagePage,pOutputWalk->ValueData.Usage);
    }
    else
    {
      wsprintf(szTempBuff,"Button; UsagePage=0x%x, MaxUsageLength=%d",pOutputWalk->UsagePage,pOutputWalk->ButtonData.MaxUsageLength);

    }
    strcpy(rWriteData[i].szLabel,szTempBuff);
    pOutputWalk++;
  } /*end for*/



  return i;
}  /*end function vPrepareWriteFields*/


BOOL CALLBACK bReadDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
  static PHID_DEVICE pDevice;
  char szTempBuff[1024];
  int iIndex;
  char szLabel[512];
  char szValue[512];
  PHID_DATA pData;
  unsigned  uLoop;
  static int iLbCounter;

  switch(message)
  {
    case WM_INITDIALOG:
                iLbCounter=0;
                pDevice=(PHID_DEVICE)lParam;
        break; /*end WM_INITDIALOG case*/



        case WM_COMMAND:
                switch(LOWORD(wParam))
                {

                  case IDC_READ:
                          Read(pDevice);
                          pData=pDevice->InputData;
                          SendDlgItemMessage(hDlg,IDC_OUTPUT,LB_ADDSTRING,0,(LONG)"-------------------------------------------");
                          iLbCounter++;
                          if(iLbCounter>MAX_LB_ITEMS)
                            SendDlgItemMessage(hDlg,IDC_OUTPUT,LB_DELETESTRING,0,0);
                          for(uLoop=0;uLoop<pDevice->InputDataLength;uLoop++)
                          {
                                  ReportToString(pData,szLabel,szValue);
                                  strcpy(szTempBuff,szLabel);
                                  strcat(szTempBuff,szValue);
                                  iIndex=SendDlgItemMessage(hDlg,IDC_OUTPUT,LB_ADDSTRING,0,(LONG)szTempBuff);
                                  SendDlgItemMessage(hDlg,IDC_OUTPUT,LB_SETCURSEL,iIndex,0);
                                  iLbCounter++;
                                  if(iLbCounter>MAX_LB_ITEMS)
                                          SendDlgItemMessage(hDlg,IDC_OUTPUT,LB_DELETESTRING,0,0);
                                  pData++;
                          } /*end for*/


                  break;

                  case IDOK:
                  case IDCANCEL:
                          EndDialog(hDlg,0);
                  break;
                }

        break;
  } /*end switch message*/
  return FALSE;
} /*end bReadDlgProc*/


VOID
ReportToString(
   PHID_DATA pData,
   PCHAR szLabel,
   PCHAR szValue
   )
{
        PCHAR   pszWalk;
        PUSAGE  pUsage;
        ULONG   i;

        if (pData->IsButtonData)
        {
                wsprintf (szLabel, "Usage Page: 0x%x, Usages: ",
                          pData->UsagePage);
                pszWalk = szValue;
                *pszWalk = 0;

                for (i=0, pUsage = pData->ButtonData.Usages;
                     i < pData->ButtonData.MaxUsageLength;
                         i++, pUsage++)
                {
                        if (0 == *pUsage)
                        {
                                break; // A usage of zero is a non button.
                        }
                        pszWalk += wsprintf (pszWalk, " 0x%x", *pUsage);
                }
        }
        else
        {
                wsprintf (szLabel, "Usage Page: 0x%x, Usage: 0x%x, Scaled: %d Value: ",
                          pData->UsagePage,
                          pData->ValueData.Usage,
                          pData->ValueData.ScaledValue);
                wsprintf (szValue, "%d", pData->ValueData.Value);
    }
}


VOID vDisplayDeviceCaps(PHID_DEVICE pDevice,HWND hControl)
{
        char szTempBuff[128];
        SendMessage(hControl,LB_RESETCONTENT,0,0);
        wsprintf(szTempBuff,"Usage Page: 0x%x",pDevice->Caps.UsagePage);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Usage: 0x%x",pDevice->Caps.Usage);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Input report byte length: %d",pDevice->Caps.InputReportByteLength);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Output report byte length %d",pDevice->Caps.OutputReportByteLength);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Feature report byte length %d",pDevice->Caps.FeatureReportByteLength);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
}

VOID vDisplayDeviceAttributes(PHID_DEVICE pDevice,HWND hControl)
{
        char szTempBuff[128];
        SendMessage(hControl,LB_RESETCONTENT,0,0);
        wsprintf(szTempBuff,"Vendor ID: 0x%x",pDevice->Attributes.VendorID);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Product ID: 0x%x",pDevice->Attributes.ProductID);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Version Number  0x%x",pDevice->Attributes.VersionNumber);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
}


VOID vDisplayButtonAttributes(PHIDP_BUTTON_CAPS pButton,HWND hControl)
{
        char szTempBuff[128];
        SendMessage(hControl,LB_RESETCONTENT,0,0);
        wsprintf(szTempBuff,"Report ID: 0x%x",pButton->ReportID);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Usage Page: 0x%x",pButton->UsagePage);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        if (pButton->IsAlias)
        {
                wsprintf(szTempBuff,"Alias");
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        }
        else
        {
                wsprintf(szTempBuff,"=====");
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        }

        if(pButton->IsRange)
        {
                wsprintf(szTempBuff,"Usage Min: 0x%x, Usage Max: 0x%x",
                             pButton->Range.UsageMin, pButton->Range.UsageMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if rage*/
        else
        {
                wsprintf(szTempBuff,"Usage: 0x%x",pButton->NotRange.Usage);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end else not range*/

        if(pButton->IsStringRange)
        {
                wsprintf(szTempBuff,"String Min: 0x%x, String Max: 0x%x",
                             pButton->Range.StringMin, pButton->Range.StringMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if IsStringRange*/
        else
        {
                wsprintf(szTempBuff,"String Index: 0x%x",pButton->NotRange.StringIndex);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end else not stringrange*/

        if(pButton->IsDesignatorRange)
        {
                wsprintf(szTempBuff,"Designator Min: 0x%x, Designator Max: 0x%x",
                             pButton->Range.DesignatorMin, pButton->Range.DesignatorMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if IsDesignatorRange*/
        else
        {
                wsprintf(szTempBuff,"Designator Index: 0x%x",pButton->NotRange.DesignatorIndex);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
    } /*end else !IsDesignatorRange*/
        if(pButton->IsAbsolute)
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)"Absolute: Yes");
        else
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)"Absolute: No");
} /*end function vDisplayButtonAttributes*/

VOID vDisplayValueAttributes(PHIDP_VALUE_CAPS pValue,HWND hControl)
{
        char szTempBuff[128];

        SendMessage(hControl,LB_RESETCONTENT,0,0);

        wsprintf(szTempBuff,"Report ID 0x%x",pValue->ReportID);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Usage Page: 0x%x",pValue->UsagePage);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Bit size: 0x%x",pValue->BitSize);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        if (pValue->IsAlias)
        {
                wsprintf(szTempBuff,"Alias");
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        }
        else
        {
                wsprintf(szTempBuff,"=====");
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        }

        if(pValue->IsRange)
        {
                wsprintf(szTempBuff,"Usage Min: 0x%x, Usage Max 0x%x",
                             pValue->Range.UsageMin, pValue->Range.UsageMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if rage*/
        else
        {
                wsprintf(szTempBuff,"Usage: 0x%x",pValue->NotRange.Usage);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end else not range*/

        wsprintf(szTempBuff,"Physical Minimum: %d, Physical Maximum: %d",
                     pValue->PhysicalMin, pValue->PhysicalMax);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        wsprintf(szTempBuff,"Logical Minimum: 0x%x, Logical Maximum: 0x%x",
                     pValue->LogicalMin, pValue->LogicalMax);
        SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);

        if(pValue->IsStringRange)
        {
                wsprintf(szTempBuff,"String  Min: 0x%x String Max 0x%x",
                             pValue->Range.StringMin, pValue->Range.StringMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if IsStringRange*/
        else
        {
                wsprintf(szTempBuff,"String Index: 0x%x",pValue->NotRange.StringIndex);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end else not stringrange*/

        if(pValue->IsDesignatorRange)
        {
                wsprintf(szTempBuff,"Designator Minimum: 0x%x, Max: 0x%x",
                             pValue->Range.DesignatorMin, pValue->Range.DesignatorMax);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
        } /*end if IsDesignatorRange*/
        else
        {
                wsprintf(szTempBuff,"Designator Index: 0x%x",pValue->NotRange.DesignatorIndex);
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
    } /*end else !IsDesignatorRange*/
        if(pValue->IsAbsolute)
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)"Absolute: Yes");
        else
                SendMessage(hControl,LB_ADDSTRING,0,(LONG)"Absolute: No");

}


VOID vDisplayInputButtons(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        PHIDP_BUTTON_CAPS pButtonCaps;
        char szTempBuff[128];
        int iIndex;

        SendMessage(hControl,LB_RESETCONTENT,0,(LONG)0);
        pButtonCaps=pDevice->InputButtonCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberInputButtonCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Input button cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pButtonCaps);
                pButtonCaps++;
        } /*end for buttoncaps*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}


VOID vDisplayOutputButtons(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        char szTempBuff[128];
        int iIndex;
        PHIDP_BUTTON_CAPS pButtonCaps;

        SendMessage(hControl,LB_RESETCONTENT,0,(LONG)0);
        pButtonCaps=pDevice->OutputButtonCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberOutputButtonCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Output button cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pButtonCaps);
                pButtonCaps++;
        } /*end for*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}

VOID vDisplayInputValues(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        char szTempBuff[128];
        int iIndex;
        PHIDP_VALUE_CAPS pValueCaps;

        SendMessage(hControl,LB_RESETCONTENT,0,0);
        pValueCaps=pDevice->InputValueCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberInputValueCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Input value cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pValueCaps);
                pValueCaps++;
        } /*end for*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}

VOID vDisplayOutputValues(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        char szTempBuff[128];
        int iIndex;
        PHIDP_VALUE_CAPS pValueCaps;


        SendMessage(hControl,LB_RESETCONTENT,0,0);
        pValueCaps=pDevice->OutputValueCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberOutputValueCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Output value cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pValueCaps);
                pValueCaps++;
        } /*end for*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}


VOID vDisplayFeatureButtons(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        char szTempBuff[128];
        int iIndex;
        PHIDP_BUTTON_CAPS pButtonCaps;

        SendMessage(hControl,LB_RESETCONTENT,0,0);
        pButtonCaps=pDevice->FeatureButtonCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberFeatureButtonCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Feature button cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pButtonCaps);
                pButtonCaps++;
        } /*end for*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}

VOID vDisplayFeatureValues(PHID_DEVICE pDevice,HWND hControl)
{
        int iLoop;
        char szTempBuff[128];
        int iIndex;
        PHIDP_VALUE_CAPS pValueCaps;

        SendMessage(hControl,LB_RESETCONTENT,0,0);
        pValueCaps=pDevice->FeatureValueCaps;
        for(iLoop=0;iLoop<pDevice->Caps.NumberFeatureValueCaps;iLoop++)
        {
                wsprintf(szTempBuff,"Feature value cap # %d",iLoop);
                iIndex=SendMessage(hControl,LB_ADDSTRING,0,(LONG)szTempBuff);
                if(iIndex!=-1)
                        SendMessage(hControl,LB_SETITEMDATA,iIndex,(LONG)pValueCaps);
                pValueCaps++;
        } /*end for*/
        SendMessage(hControl,LB_SETCURSEL,0,0);
}


VOID vLoadItemTypes(HWND hItemTypes)
{
        int iIndex;


        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"INPUT BUTTON");
        if(iIndex!=-1)
                SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,INPUT_BUTTON);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"INPUT VALUE");
        if(iIndex!=-1)
                SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,INPUT_VALUE);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"OUTPUT BUTTON");
        if(iIndex!=-1)
                SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,OUTPUT_BUTTON);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"OUTPUT VALUE");
        if(iIndex!=-1)
                SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,OUTPUT_VALUE);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"FEATURE BUTTON");
        if(iIndex!=-1)
          SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,FEATURE_BUTTON);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"FEATURE VALUE");
        if(iIndex!=-1)
          SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,FEATURE_VALUE);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"HID CAPS");
        if(iIndex!=-1)
          SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,HID_CAPS);

        iIndex=SendMessage(hItemTypes,CB_ADDSTRING,0,(LONG)"DEVICE ATTRIBUTES");
        if(iIndex!=-1)
          SendMessage(hItemTypes,CB_SETITEMDATA,iIndex,DEVICE_ATTRIBUTES);



        SendMessage(hItemTypes,CB_SETCURSEL,0,0);




} /*end function vLoadItemTypes*/


VOID vLoadDevices(HWND hDeviceCombo)
{
        PHID_DEVICE HidDevices;
        PHID_DEVICE pWalk;
        ULONG ulCount;
        BOOL bReturn;
        unsigned  uiLoop;
        char szTempBuff[128];
        int iIndex;

        bReturn=FindKnownHidDevices(&HidDevices,&ulCount);
        if(bReturn)
        {
          pWalk=HidDevices;
          for(uiLoop=0;uiLoop<ulCount;uiLoop++)
          {
            wsprintf(szTempBuff,"Device %d, UsagePage 0%x, Usage 0%x",pWalk->HidDevice,pWalk->Caps.UsagePage,pWalk->Caps.Usage);
                iIndex=SendMessage(hDeviceCombo,CB_ADDSTRING,0,(long)szTempBuff);
                if(iIndex!=-1)
                  SendMessage(hDeviceCombo,CB_SETITEMDATA,iIndex,(LONG)pWalk);
            pWalk++;
          } /*end for*/
          SendMessage(hDeviceCombo,CB_SETCURSEL,0,0);

        } /*end if FindKnownHidDevices returned TRUE*/




} /*end function vLoadDevices*/



BOOL bGetWriteData(prWriteDataStruct pItems,int iCount,HWND hParent)
{
        rWriteDataStruct arTempItems[MAX_WRITE_ELEMENTS];
        int iResult;
        rGetWriteDataParams rParams;


        if(iCount>MAX_WRITE_ELEMENTS)
                iCount=MAX_WRITE_ELEMENTS;
        memcpy(&(arTempItems[0]),pItems,sizeof(rWriteDataStruct)*iCount);
        rParams.iCount=iCount;
        rParams.prItems=&(arTempItems[0]);
        iResult=DialogBoxParam(hGInstance,"WRITEDATA",hParent,bGetDataDlgProc,(LPARAM)&rParams);
        if(iResult)
                memcpy(pItems,arTempItems,sizeof(rWriteDataStruct)*iCount);
  return iResult;
} /*end function bGetWriteData*/



BOOL CALLBACK bGetDataDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
        static prWriteDataStruct prData;
        static prGetWriteDataParams pParams;
        static int iDisplayCount;
        static int iScrollRange;
        static int iCurrentScrollPos=0;
        static HWND hScrollBar;
        int iTemp;
        SCROLLINFO rScrollInfo;
        int iReturn;

        switch(message)
        {
          case WM_INITDIALOG:
                  pParams=(prGetWriteDataParams)lParam;
                  prData=pParams->prItems;
                  hScrollBar=GetDlgItem(hDlg,IDC_SCROLLBAR);
                  if(pParams->iCount>CONTROL_COUNT)
                  {
                          iDisplayCount=CONTROL_COUNT;
                          iScrollRange=pParams->iCount-CONTROL_COUNT;
                          rScrollInfo.fMask=SIF_RANGE|SIF_POS;
                          rScrollInfo.nPos=0;
                          rScrollInfo.nMin=0;
                          rScrollInfo.nMax=iScrollRange;
                          rScrollInfo.cbSize=sizeof(rScrollInfo);
                          rScrollInfo.nPage=CONTROL_COUNT;
                          iReturn=SetScrollInfo(hScrollBar,SB_CTL,&rScrollInfo,TRUE);
                  }
                  else
                  {
                          iDisplayCount=pParams->iCount;
                          EnableWindow(hScrollBar,FALSE);


                  }
                  vWriteDataToControls(hDlg,prData,0,pParams->iCount);


          break;

          case WM_COMMAND:
                  switch(LOWORD(wParam))
                  {
                    case IDOK:
                        case ID_SEND:
                                vReadDataFromControls(hDlg,prData,iCurrentScrollPos,iDisplayCount);
                                EndDialog(hDlg,1);
                        break;

                        case IDCANCEL:
                                EndDialog(hDlg,0);
                        break;
                  } /*end switch loword wParam*/
          break;

          case WM_VSCROLL:
                  vReadDataFromControls(hDlg,prData,iCurrentScrollPos,iDisplayCount);
                  switch(LOWORD(wParam))
                  {
                    case SB_LINEDOWN:
                          ++iCurrentScrollPos;

                        break;

                        case SB_LINEUP:
                                --iCurrentScrollPos;
                        break;

                        case SB_THUMBPOSITION:
                                iCurrentScrollPos=HIWORD(wParam);

                        case SB_PAGEUP:
                                iCurrentScrollPos-=CONTROL_COUNT;

                        break;

                        case SB_PAGEDOWN:
                                iCurrentScrollPos+=CONTROL_COUNT;

                        break;
          }
                  if(iCurrentScrollPos<0)
                          iCurrentScrollPos=0;
                  if(iCurrentScrollPos>iScrollRange)
                          iCurrentScrollPos=iScrollRange;
                  SendMessage(hScrollBar,SBM_SETPOS,iCurrentScrollPos,TRUE);
                  iTemp=LOWORD(wParam);
                  if((iTemp==SB_LINEDOWN)||(iTemp==SB_LINEUP)||(iTemp==SB_THUMBPOSITION)||(iTemp==SB_PAGEUP)||(iTemp==SB_PAGEDOWN))
                          vWriteDataToControls(hDlg,prData,iCurrentScrollPos,iDisplayCount);

          break; //case WM_VSCROLL


        } /*end switch (message)*/
 return FALSE;

} /*end function bGetDataDlgProc*/

VOID vReadDataFromControls(HWND hDlg,prWriteDataStruct prData,int iOffset,int iCount)
{
        int iLoop;
        int iValueControlID=IDC_OUT_EDIT1;
        prWriteDataStruct pDataWalk;
        HWND hValueWnd;

        pDataWalk=prData+iOffset;
        for(iLoop=0;(iLoop<iCount)&&(iLoop<CONTROL_COUNT);iLoop++)
        {
                hValueWnd=GetDlgItem(hDlg,iValueControlID);
                GetWindowText(hValueWnd,pDataWalk->szValue,MAX_VALUE);
                iValueControlID++;
                pDataWalk++;
        } /*end for*/


} /*End function vReadDataFromControls*/

VOID vWriteDataToControls(HWND hDlg,prWriteDataStruct prData,int iOffset,int iCount)
{
        int iLoop;
        int iLabelControlID=IDC_OUT_LABEL1;
        int iValueControlID=IDC_OUT_EDIT1;
        HWND hLabelWnd,hValueWnd;
        prWriteDataStruct pDataWalk;

        pDataWalk=prData+iOffset;
        for(iLoop=0;(iLoop<iCount)&&(iLoop<CONTROL_COUNT);iLoop++)
        {
                hLabelWnd=GetDlgItem(hDlg,iLabelControlID);
                hValueWnd=GetDlgItem(hDlg,iValueControlID);
                ShowWindow(hLabelWnd,SW_SHOW);
                ShowWindow(hValueWnd,SW_SHOW);
                SetWindowText(hLabelWnd,pDataWalk->szLabel);
                SetWindowText(hValueWnd,pDataWalk->szValue);
                iLabelControlID++;
                iValueControlID++;
                pDataWalk++;
        } /*end for*/
        for(;iLoop<CONTROL_COUNT;iLoop++)
        {
                hLabelWnd=GetDlgItem(hDlg,iLabelControlID);
                hValueWnd=GetDlgItem(hDlg,iValueControlID);
                ShowWindow(hLabelWnd,SW_HIDE);
                ShowWindow(hValueWnd,SW_HIDE);
                iLabelControlID++;
                iValueControlID++;
        } /*end for loop to hide controls*/
} /*end function vWriteDataToControls*/

