
/*++

Copyright (c) 1996  Microsoft Corporation

Module Name:

   proto.h

Abstract:

   This is the WDM sample streaming class minidriver.  This module contains
   function prototypes for public functions

Author:

Environment:

   Kernel mode only


Revision History:

--*/

//
// This is the prototype for the Hardware Interrupt Handler.  This routine
// will be called whenever the minidriver receives an interrupt
//

BOOLEAN HwInterrupt ( IN PHW_DEVICE_EXTENSION pDeviceExtension );

//
// This is the prototype for the stream enumeration function.  This routine
// provides the stream class driver with the information on data stream types
// supported
//

VOID AdapterStreamInfo(PHW_STREAM_REQUEST_BLOCK pSrb);

//
// This is the prototype for the stream open function
//

VOID AdapterOpenStream(PHW_STREAM_REQUEST_BLOCK pSrb);

//
// This is the prototype for the stream close function
//

VOID AdapterCloseStream(PHW_STREAM_REQUEST_BLOCK pSrb);

//
// This is the prototype for the AdapterReceivePacket routine.  This is the
// entry point for command packets that are sent to the adapter (not to a
// specific open stream)
//

VOID STREAMAPI AdapterReceivePacket(IN PHW_STREAM_REQUEST_BLOCK Srb);

//
// This is the protoype for the cancel packet routine.  This routine enables
// the stream class driver to cancel an outstanding packet.
//

VOID STREAMAPI AdapterCancelPacket(IN PHW_STREAM_REQUEST_BLOCK Srb);

//
// This is the packet timeout function.  The adapter may choose to ignore a
// packet timeout, or rest the adapter and cancel the requests, as required.
//

VOID STREAMAPI AdapterTimeoutPacket(IN PHW_STREAM_REQUEST_BLOCK Srb);

//
// This is the prototype for the StreamReceiveDataPacket routine.  This is the
// entry point for data command packets that are sent to an open data stream 
//

VOID STREAMAPI VideoReceiveDataPacket(IN PHW_STREAM_REQUEST_BLOCK pSrb);
VOID STREAMAPI AudioReceiveDataPacket(IN PHW_STREAM_REQUEST_BLOCK pSrb);
//
// This is the prototype for the StreamReceiveCtrlPacket routine.  This is the
// entry point for control command packets that are sent to an open data stream 
//

VOID STREAMAPI VideoReceiveCtrlPacket(IN PHW_STREAM_REQUEST_BLOCK pSrb);
VOID STREAMAPI AudioReceiveCtrlPacket(IN PHW_STREAM_REQUEST_BLOCK pSrb);

//
// prototypes for data handling routines
//

VOID StartDataPacket(PHW_STREAM_REQUEST_BLOCK pSrb);
VOID ProcessDataPacket(PHW_STREAM_OBJECT pstrm);
VOID AudioPacketStub(PHW_STREAM_OBJECT pstrm);
VOID VideoPacketStub(PHW_STREAM_OBJECT pstrm);
void EnableIRQ(PHW_STREAM_OBJECT pstrm);
void DisableIRQ(PHW_STREAM_OBJECT pstrm);

//
// prototypes for properties and states
//


VOID SetVideoState(PHW_STREAM_REQUEST_BLOCK pSrb);
void GetVidLvl(PHW_STREAM_REQUEST_BLOCK pSrb);
VOID GetVideoProperty(PHW_STREAM_REQUEST_BLOCK pSrb);
VOID SetAudioState(PHW_STREAM_REQUEST_BLOCK pSrb);
void GetAudLvl(PHW_STREAM_REQUEST_BLOCK pSrb);
VOID GetAudioProperty(PHW_STREAM_REQUEST_BLOCK pSrb);
VOID SetAudioProperty(PHW_STREAM_REQUEST_BLOCK pSrb);

