

/*++

Copyright (c) 1996  Microsoft Corporation

Module Name:

   mpaudio.c

Abstract:

   This is the WDM sample streaming class minidriver.  This module contains
   code related to processing individual audio commands

Author:

Environment:

   Kernel mode only


Revision History:

--*/


#include "common.h"
#include "ks.h"
#include "ksguid.h"
#include "mpegprop.h"


/*
** GetAudioProperty()
**
**    Routine to process Audio property requests
**
** Arguments:
**
**    pSrb - pointer to the stream request block for properties
**
** Returns:
**
** Side Effects:  none
*/

VOID GetAudioProperty(PHW_STREAM_REQUEST_BLOCK pSrb)
{
	PHW_DEVICE_EXTENSION phwdevext =
		((PHW_DEVICE_EXTENSION)pSrb->HwDeviceExtension);

    //
    // determine which property set is being requested
    //

	switch (pSrb->CommandData.PropertyInfo->PropertySetID)
	{

    //
    // zero is the first property, which is the get buffer level
    //

	case 0:

	    GetAudLvl(pSrb);

		break;

	default:

        break;


	}
	pSrb->Status = STATUS_SUCCESS;

}

/*
** GetAudLvl()
**
**    Completes the Audio buffer level property
**
** Arguments:
**
**    pSrb - pointer to the stream request block for properties
**
** Returns:
**
** Side Effects:  none
*/

void GetAudLvl(PHW_STREAM_REQUEST_BLOCK pSrb)
{
#define BUF_FULL 0;

	//
	// set the max buffer to the buffer full level
	//

	((PBUF_LVL_DATA)(pSrb->CommandData.PropertyInfo->PropertyInfo))
                ->BufferCapacity = BUF_FULL;

	//
	// set current to the current Audio level
	//

	//((PBUF_LVL_DATA)(pSrb->CommandData.PropertyInfo->PropertyInfo))
    //            ->CurBufferLevel = GetAudioBufferLevel(pSrb);

    //
    // indicate the amount of data that is being returned
    //

	pSrb->ActualBytesTransferred = sizeof (BUF_LVL_DATA);

}

/*
** SetAudioState()
**
**    Sets the current state of the requested stream
**
** Arguments:
**
**    pSrb - pointer to the stream request block for properties
**
** Returns:
**
** Side Effects:  none
*/

VOID SetAudioState(PHW_STREAM_REQUEST_BLOCK pSrb)
{
	PHW_DEVICE_EXTENSION phwdevext =
		((PHW_DEVICE_EXTENSION)pSrb->HwDeviceExtension);

    //
    // determine which new state is requested
    //

	switch (pSrb->CommandData.StreamState)  
	{
	case KSSTATE_STOP:

        //
        // stop the Audio
        //

        // AudioStop(pSrb, phwdevext);

		break;


	case KSSTATE_PAUSE:

        //
        // pause the Audio
        //

		// AudioPause(pSrb, phwdevext);

		break;

	case KSSTATE_RUN:

        //
        // play the Audio
        //

		// AudioPlay(pSrb, phwdevext);

        break;

	}
	pSrb->Status = STATUS_SUCCESS;

}

