


/*++

Copyright (c) 1996  Microsoft Corporation

Module Name:

   strmid.h

Abstract:

   This is the WDM sample streaming class minidriver.  This module contains
   header definitions to define the stream types that this mini driver supports
   This information is used by the Enumerate Stream types routine.

Author:

Environment:

   Kernel mode only


Revision History:

--*/

#include "ksmedia.h"
#include "mpeg2ids.h"
#include "mpegprop.h"
//#include "ksguid.h"
//#include "mpegguid.h"

/*****************************************************************************

                Definitions of Supported Stream Types

*****************************************************************************/

/*

 Define the Mpeg2Video format that the minidriver supports

 */

KSDATAFORMAT hwfmtiMpeg2Vid
     = {

     sizeof (KSDATAFORMAT),
     0,

	 //
	 // specify media type, subtype, and format from mpeg2 video
	 //

     STATIC_KSDATAFORMAT_TYPE_MPEG2_PES,
	 STATIC_KSDATAFORMAT_SUBTYPE_MPEG2_VIDEO,
	 STATIC_KSDATAFORMAT_SPECIFIER_MPEG2_VIDEO

	};

/*

 Define the supported AC3 Audio format

 */

KSDATAFORMAT hwfmtiMpeg2Aud
    = {
	sizeof (KSDATAFORMAT),
    0,
    STATIC_KSDATAFORMAT_TYPE_MPEG2_PES,
    STATIC_KSDATAFORMAT_SUBTYPE_AC3_AUDIO,
    STATIC_KSDATAFORMAT_SPECIFIER_WAVEFORMATEX
	};

/*

  Define the NTSC Composite output format

 */

KSDATAFORMAT hwfmtiNtscOut;
    /* = {
    // bugbug need to define these GUID's

	};
*/

//
// this array indicates that stream 0 (as constructed in sscmd.c) supports
// the MPEG 2 video format.  If stream zero supported more formats, the 
// addresses of these formats would be additional elements in this array.
//

PKSDATAFORMAT Mpeg2VidInfo[] = {
    &hwfmtiMpeg2Vid  // pointer to the MPEG 2 video format block
};        
        
//
// this structure indicates that stream 1 (as constructed in sscmd.c) supports
// the MPEG 2 audio format.  If stream 1 supported more formats, the 
// addresses of these formats would be additional elements in this array.
//

PKSDATAFORMAT Mpeg2AudInfo[] = {
    &hwfmtiMpeg2Aud,  // pointer to the MPEG 2 audio format block
};        


//
// this structure indicates that stream 2 (as constructed in sscmd.c) supports
// the NTSC composite format.  If stream 1 supported more formats, the 
// addresses of these formats would be additional elements in this array.
//

PKSDATAFORMAT NtscInfo[] = {
    &hwfmtiNtscOut  // pointer to the NTSC nnformat block
};



/*****************************************************************************

                Definitions of Supported Stream Properties

*****************************************************************************/

//
// define the individual MPEG2 properties that this mini driver supports
// This is only the buffer level property right now.
//


static const KSPROPERTY_ITEM mpegVidPropItm[]={
	{0,
	(PFNKSHANDLER) TRUE,
	sizeof (KSPROPERTY),
	sizeof (BUF_LVL_DATA),
	FALSE,
	NULL,
	0,
	NULL,
	NULL,
	0
	}};

//
// Define the array of properties that the video stream supports
//

GUID Mpeg2Vid = {STATIC_KSPROPSETID_Mpeg2Vid};

static const KSPROPERTY_SET mpegVidPropSet[] = {
		&Mpeg2Vid,
		SIZEOF_ARRAY(mpegVidPropItm),
		(PKSPROPERTY_ITEM)mpegVidPropItm
		};



