/*++

Copyright (c) 1995  Microsoft Corporation

Module Name:

    dbg.h

Abstract:

    Debug Code for 1394 drivers.

Environment:

    kernel mode only

Notes:

Revision History:

    5-Sep-95

--*/



//
// Various definitions
//
// #define TRAP()      _asm int 3
#define TRAP()      DbgBreakPoint()

#define SONYDCAM_ASSERT( exp ) \
    if (!(exp)) \
        Debug_Assert( #exp, __FILE__, __LINE__, NULL )

#define SONYDCAM_ASSERTMSG( msg, exp ) \
    if (!(exp)) \
        Debug_Assert( #exp, __FILE__, __LINE__, msg )



//
// Function declarations
//
VOID
Debug_Assert(
    IN PVOID FailedAssertion,
    IN PVOID FileName,
    IN ULONG LineNumber,
    IN PCHAR Message
    );

VOID 
Debug_LogEntry(
    IN CHAR *Name, 
    IN ULONG Info1, 
    IN ULONG Info2, 
    IN ULONG Info3
    );

VOID
Debug_LogInit(
    );





